function colorWheel(X,Y,Z,center,isocontours)

    Z = Z-center; % color wheel centered at "center"

    H = (pi+angle(Z))/(2*pi);
    %S = 0.5*ones(size(Z));
    %V = max(0.25,mod(abs(Z)*10,1));
    %V =abs(Z)/max(max(abs(Z)));
    V = (abs(Z)/max(max(abs(Z)))).^0.25;
    S = (abs(Z)/max(max(abs(Z)))).^0.25;
%     V = ones(size(Z));
%     S = max(0.5,abs(Z));
    
    [n,m,~]=size(Z);
    
    HSV_image = zeros(n,m,3);
    
    HSV_image(:,:,1)=H;
    HSV_image(:,:,2)=S;
    HSV_image(:,:,3)=V;
    
    I = hsv2rgb(HSV_image);
    
    f=figure;
    set(f,'Position',[1 1 1001 1001])
    imagesc([min(min(X)),max(max(X))],[min(min(Y)),max(max(Y))],I)
    if isocontours
        hold on
        contour(X,Y,real(Z),'linewidth',2,'color',[0.1, 0.1, 0.1]);
        hold on
        contour(X,Y,imag(Z),'linewidth',2,'color',[0.1, 0.1, 0.1]);
    end
    xlim([min(min(X)),max(max(X))])
    ylim([min(min(Y)),max(max(Y))])
    set(gca,'fontsize',20,'linewidth',2)
    set(gca,'YDir','normal')
    axis 'square'
    