function [K,X,Y] = getK_Marmousi(N,setup)

    h = setup.domainHeight/(N+setup.delta);

    [ci,xi,yi] = interpMarmusi(N,setup);
    
    X = xi;
    Y = yi;
    K = (ci.^-1);
    
    K = setup.K_max*K/max(max(K));
    
    % only plot K(x,y) if we are on the top level.
    
    K = K';
    
    if setup.plotSurfaces && N == 2^setup.level-setup.delta
        X = X'/1000;
        Y = Y'/1000;
        figure
        surf(X,Y,K,'EdgeColor','None')
        title('k(x,y)')
        xlabel('x')
        ylabel('y')
        xlim([0 9])
        ylim([0 3])
        set(gca,'fontsize',20,'LineWidth',2)
    end
    
    