function [ki,xi,yi] = interpMarmusi(N,setup)
% [m] = interpMarmusi(n)
%
load marmousi.mat

[vel,x,y]=marmousi_velocity();

n_x = length(x);
n_y = length(y);

x = kron(ones(n_y,1),x);
y = kron(y,ones(1,n_x));

h = 3000/(N+setup.delta);

if strcmp(setup.type,'cell-centered')
    [xi,yi]=ndgrid(linspace(h/2,9000-h/2,3*N),linspace(h/2,3000-h/2,N));
elseif strcmp(setup.type,'vertex-centered')
    [xi,yi] = ndgrid(linspace(h,9000-h,3*N+2),linspace(h,3000-h,N));
end

ki = interpn(x',y',vel',xi,yi,'linear');
