function [A,c,c_m]=extract_matrix_entrees(L_h,N,setup)

    d = setup.dimension;
    
    if d==2

        A=full(diag(L_h));
        c1p = full(diag(L_h,1));
        c1m = full(diag(L_h,-1));
        c1p = [c1p;0];
        c1m = [0;c1m];

        Ip = speye(N);
        Ip(N,N)=0;
        Im = sparse(N,N);
        Im(N,N)=1;
        I = speye(N);

        Ipp = kron(I,Ip);
        Imm = kron(I,Im);

        c1 = Ipp*c1p+Imm*c1m;

        c2p = [full(diag(L_h,N));zeros(N,1)];
        c2m = [zeros(N,1);full(diag(L_h,-N))];

        Ipp = kron(Ip,I);
        Imm = kron(Im,I);

        c2 = Ipp*c2p+Imm*c2m;
        
        % matrix off diagonal entrees are negated by convention
        c1 = -c1;
        c2 = -c2;
        
        c = c1+c2;
        c_m = min([c1,c2],[],2); % elementwise min of c1,c2
        
    elseif d==3
        
        A=full(diag(L_h));
        c1p = full(diag(L_h,1));
        c1m = full(diag(L_h,-1));
        c1p = [c1p;0];
        c1m = [0;c1m];

        Ip = speye(N);
        Ip(N,N)=0;
        Im = sparse(N,N);
        Im(N,N)=1;
        I = speye(N);

        Ip1 = kron(kron(I,I),Ip);
        Im1 = kron(kron(I,I),Im);

        c1 = Ip1*c1p+Im1*c1m;



        c2p = [full(diag(L_h,N));zeros(N,1)];
        c2m = [zeros(N,1);full(diag(L_h,-N))];

        Ip2 = kron(kron(I,Ip),I);
        Im2 = kron(kron(I,Im),I);

        c2 = Ip2*c2p+Im2*c2m;


        c3p = [full(diag(L_h,N^2));zeros(N^2,1)];
        c3m = [zeros(N^2,1);full(diag(L_h,-N^2))];

        Ip3 = kron(kron(Ip,I),I);
        Im3 = kron(kron(Im,I),I);

        c3 = Ip3*c3p+Im3*c3m;
        
        % matrix off diagonal entrees are negated by convention
        c1 = -c1;
        c2 = -c2;
        c3 = -c3;
        
        c = c1+c2+c3;
        c_m = min([c1,c2,c3],[],2); % elementwise min of c1,c2,c3
        
    else
       error('invalid dimension') 
    end
    
    
    