function f = getRandomRHS(Ls,setup,iteration)

    d = setup.dimension;
    N = 2^(setup.level)-setup.delta;
    
    h = setup.domainHeight/(N+setup.delta);
    if ~strcmp(setup.coefficients,'Marmousi')
        rand_vec = rand(N^d,1);
        if strcmp(setup.type,'vertex-centered')
            x = h:h:1-h;
        else
            x = h/2:h:1-h/2;
        end
        if d==2
            [X,Y]=meshgrid(x);
        else
            [X,Y,Z]=meshgrid(x);
        end
            
    else
        M = 3*N+2*setup.delta;
        if strcmp(setup.type,'vertex-centered')
            x = h:h:9-h;
            y = h:h:3-h;
        elseif strcmp(setup.type,'cell-centered')
            x = h/2:h:9-h/2;
            y = h/2:h:3-h/2;
        end
       [X,Y]=meshgrid(x,y);
        rand_vec = rand(N*M,1);
    end
    
    L_h = Ls{setup.level};
    
    rand_vec = L_h*rand_vec;
    
    f = h^2*rand_vec;
    
    if setup.plotSurfaces && iteration == setup.numRandomIt
        if strcmp(setup.coefficients,'Marmousi')
            rand_vec = reshape(rand_vec,[N,M]);
        elseif d==2
            rand_vec = reshape(rand_vec,[N,N]);
        end
        if d==3
            rand_vec = reshape(rand_vec,[N,N,N]);
            [X,Y,rand_vec]=get_F_mid(X,Y,rand_vec);
        end

        figure
        surf(X,Y,real(rand_vec),'Edgecolor','None')
        xlabel('x')
        ylabel('y')
        if d==2
            title('random rhs')
        else
            title('random rhs (z = 0.5 slice)')
        end
        set(gca,'fontsize',20,'LineWidth',2)
    end