function stencil_data = getStencilData(Ls,setup)

    d = setup.dimension;

    stencil_data = {};

    for l = setup.minLevel+1:setup.level
        
        % Extract the stencil for the present level.  
        % We do this straightforwardly by extracting relevant matrix entrees,
        % assuming a lexicographic ordering (this will break if the
        % matrices have already been permuted to red-black ordering)

        % note that this process only makes sense for constant
        % coefficients
        L = Ls{l};

        [N_to_the_d,~]=size(L);
        N = round(N_to_the_d^(1/d));

        a=full(L(1,1));
        c1=-full(L(1,2));
        c2=-full(L(1,1+N));
        

        if d > 2
            c3=-full(L(1,1+N^2));
            c = c1+c2+c3;
            c_m = min([c1,c2,c3]);
        else
            c = c1+c2;
            c_m = min([c1,c2]);
        end
        
        stencil_data{l}=[a,c,c_m];
        
    end