function [w,res] = manuallyFindOptimalDampingParameterOverC(Ls,Ps,Rs,setup)

    M = 101; % split [0,2] x [-1,1] into an M x M grid.

    f = getRandomRHS(Ls,setup);
    
    
    bestW = [0;0];
    bestRes = inf;
    N = length(f);
    
    u0 = zeros(N,1);
    
    % find the best omega in this grid.
    
    for j=1:M
        display([' scanning line j = ',num2str(j),' of ',num2str(M)])
        for k=1:M
            W = [2*(j-1)/(M-1);-1+2*(k-1)/(M-1)];
            
            if (W(1)-1)^2+W(2)^2<1
                res = runMultigridAwhile(Ls,Ps,Rs,W,u0,f,setup);
                
                if res < bestRes
                    bestRes = res;
                    bestW = W;
                end
            end
            
        end
        
    end
    
    % use it as an initial guess for minimization.
    
    f = @(W)runMultigridAwhile(Ls,Ps,Rs,W,u0,f,setup);
    W0 = bestW;

    options = optimset('TolX',1e-8,'MaxFunEvals',1000);
    [W,fval,exitflag,output] = fminsearch(f,W0,options);
    
    % keep the result if it is better.
    
    if fval < bestRes
        w = W(1)+1i*W(2);
        res = fval;
    else
        w = bestW(1)+1i*bestW(2);
        res = bestRes;
    end


        
end

