function plotSolution(u,setup)

    N = 2^setup.level-setup.delta;
    
    h = setup.domainHeight/(N+setup.delta);
    
    d = setup.dimension;

    if strcmp(setup.coefficients,'Marmousi')
        x_max = 9;
        y_max = 3;
        if strcmp(setup.type,'vertex-centered')
            x = h:h:9-h;
            y = h:h:3-h;
        elseif strcmp(setup.type,'cell-centered')
            x = h/2:h:9-h/2;
            y = h/2:h:3-h/2;
       end 
        
       [X,Y]=meshgrid(x,y);
       U = reshape(u,[N,3*N+2*setup.delta]);
    else
        x_max = 1;
        y_max = 1;
        if strcmp(setup.type,'vertex-centered')
            x = h:h:1-h;
        elseif strcmp(setup.type,'cell-centered')
            x = h/2:h:1-h/2;
        end
       if d==2
           [X,Y]=meshgrid(x);
           U = reshape(u,[N,N]);
       elseif d==3
           [X,Y,~]=meshgrid(x,x,x);
           U = reshape(u,[N,N,N]);
           [X,Y,U]=get_F_mid(X,Y,U);
       end
    end
    
    figure
    if setup.increaseWaveVisibility
        surf(X,Y,abs(real(U)).^0.1.*sign(real(U)),'Edgecolor','None')
        %robsVisualization(X,Y,abs(U).^0.01.*U./abs(U))
    else
        surf(X,Y,real(U),'Edgecolor','None')
    end
     xlabel('x')
     ylabel('y')
    xlim([0 x_max]);
    ylim([0 y_max]);
    if d==2
        title('Real part of solution ')
    else
        title('Real part of solution  (z=0.5 slice)')
    end
    set(gca,'fontsize',20,'LineWidth',2)
       