function printMultigridData(u,multigrid_rates,multigrid_iterations,multigrid_runtimes,setup)

    nu = setup.nu;    

    multigrid_rate = mean(multigrid_rates);
    iterations = mean(multigrid_iterations);
    runtime = mean(multigrid_runtimes);
    if strcmp(setup.coefficients,'constant')
        if ~strcmp(setup.strategy,'two-grid')
            convergenceMeasure = 'mu^nu';
        else
            convergenceMeasure = 'rho_2G';
        end
        for l=setup.level:-1:setup.minLevel+1
            display(['On level ',num2str(setup.level-l),' omega = ',num2str(setup.dampingParameters(l)),' and ',num2str(convergenceMeasure),' = ',num2str(setup.smoothingFactors(l)^nu)]);
        end
    end
    
    display(['Multigrid avg convergence rate is = ',num2str(multigrid_rate)])
    display(['Multigrid avg iterations = ',num2str(iterations)])
    display(['Multigrid avg runtime = ',num2str(runtime)])
    display(['Number of degrees of freedom = ',num2str(length(u))])