function res = runMultigridAwhile(Ls,Ps,Rs,W,u0,f,setup)

    % approximate the multigrid convergence rate with the average over M
    % iterations (we take M = 20).
    
    w = W(1)+1i*W(2);
    
    u = u0;
    
    L = Ls{setup.level};
    
    setup.dampingParameters = ones(setup.level,1)*w;
    r = f-L*u;
    count = 0;
    r0 = sqrt(r'*r);
    M = 20;
    setup.levelCounts = zeros(setup.level,1);
    while sqrt(r'*r)/r0 < 10^6 && count < M
        
        %display(['count=',num2str(count),' ||r|| ',num2str(sqrt(r'*r))])
        u = FCYC(Ls,Ps,Rs,u,f,setup.level,setup);
        setup.levelCounts = zeros(setup.level,1);
        r = f-L*u;
        count=count+1;
    end
    
    res = (sqrt(r'*r)/r0)^(1/M);
    
    