clear all;

N = 101;
M = 201;

Lookup = zeros(M,N,N,4);

w0_1 = []; % initial guess, empty to start with.
w0_2 = [];

for j=1:M
    display(['j = ',num2str(j),' of ',num2str(M)])
    u = (j-1)/(M-1);
    for k=1:N
        v = (k-1)/(N-1);
        for l=1:N
            w = (l-1)/(N-1);
            c = 0.5;
            r = 2*u;
            c_m = v*c*0.5;
            phi = pi*w;
            A = r*exp(1i*phi);
            [wC1,muC1,wC2,muC2]=optimalRB_SOR_values(c,c_m,A,w0_1,w0_2);
            if abs(muC1-1)<1e-3
                muC1 = 1;
                wC1 = 0;
            end
            if abs(muC2-1)<1e-3
                muC2 = 1;
                wC2 = 0;
            end
            w0_1 = [real(wC1);imag(wC1)];
            w0_2 = [real(wC2);imag(wC2)];
            Lookup(j,k,l,1)=wC1;
            Lookup(j,k,l,2)=muC1;
            Lookup(j,k,l,3)=wC2;
            Lookup(j,k,l,4)=muC2;
        end
    end
end

save UniversalLookup4.mat Lookup4