function R = getR_2g(setup,theta1,theta2,level)

    % somewhat counterintuitively, R_2g is not necessarily the operator on
    % level two.  Hence level is an explicit parameter
    
    R = zeros(1,4);
    
    alpha = [0 1 1 0;
        0 1 0 1];
    
    Rstencil =  setup.R{level};
    
    A = Rstencil(1);
    B = Rstencil(2);
    C = Rstencil(3);
    D = Rstencil(4);
    
    for l=1:4
        
        alphaX = alpha(1,l);
        alphaY = alpha(2,l);
        
        theta1p = theta1-(alphaX*mod_sign(theta1))*pi;
        theta2p = theta2-(alphaY*mod_sign(theta2))*pi;
        
        R(1,l)=A+2*B*cos(theta1p)+2*C*cos(theta2p)+4*D*cos(theta1p)*cos(theta2p);
        
    end
    

        
    
