function S = getS(setup,level,x,y)

    % we need to know which level we are on.
    
    stencil =  setup.L{level};
    
    A = stencil(1);
    B = stencil(2);
    C = stencil(3);
    D = stencil(4);
    
    w = setup.w;
    
    
    c1 = cos(x);
    c2 = cos(y);
    
    if strcmp(setup.smoother,'RB-SOR')  % S is a 2x2 matrix in this case
        
        S = zeros(2,2);
        
        X1 = -2*B*c1-2*C*c2-4*D*c1*c2;
        X2 = 2*B*c1+2*C*c2-4*D*c1*c2;
        
        sw = 1-w*(1-X1/A);
		swp = 1-w*(1-X2/A);
		
		S(1,1)=( (sw+1)*(sw+1)+(swp-1)*(1-sw) )/4;
		S(1,2)=( swp*swp-1+(sw+1)*(1-swp) )/4;
		S(2,1)=( sw*sw-1+(swp+1)*(1-sw) )/4;
		S(2,2)=( (swp+1)*(swp+1)+(swp-1)*(1-sw) )/4;
    
    elseif strcmp(setup.smoother,'damped-Jacobi')   % S is scalar in this case

        X = -2*B*c1-2*C*c2-4*D*c1*c2;
        S = 1-w*(1-X/A);
        
    end